#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "dpiutil.h"
#include "../osdep/strl.c"

static unsigned int readbig(char *ptr);
static void processstring(char *str);

static unsigned int readbig(char *ptr) {
  unsigned char *p = (unsigned char *) ptr;
  unsigned int x = p[3]+ (p[2]<<8) + (p[1]<<16) + (p[0]<<24);
  return x;
}

static void processstring(char *str) {
  int i=0;
  while(str[i]) {
    if(str[i]=='\n') str[i] = ' ';
    i++;
  }
}

void processdeliplayer(char *credits, char *filename, int credits_len) {
  char buf[1025];
  int i;
  unsigned int x,y;
  FILE *File;
  unsigned int *tab;
  char *beg;

  if (credits)
    *credits = 0;

  File = fopen(filename,"r");
  if(!File)
    return;

  i = fread(buf, 1, 1024, File);
  fclose(File); File = 0;
  buf[1024] = 0;


  if (readbig(buf) == 0x000003f3) {

    for (i=0;i<900;i++) {

      if (readbig(buf+i) == 0x70ff4e75) {

	int is_amplifier = 0;
	int is_customplayer = 0;
	int is_noteplayer = 0;
	int has_songend = 0;

	if (strncmp(buf+i+4,"DELIRIUM",8)==0 ||
	    strncmp(buf+i+4,"EPPLAYER",8)==0    ) {
	  if (!credits) {
	    printf("filename:\t%s\n",filename);
	  }
	  beg = buf+i;
	  tab = (unsigned int *) (beg+readbig(beg+12));
	  if (beg[16] == '$' && beg[17] == 'V'){
	    if (credits) {
	      strlcpy(credits, "VERSION:\n", credits_len);
	      strlcat(credits, beg+16, credits_len);
	      strlcat(credits, "\n\n", credits_len);
	    } else {
	      printf("version:\t%s\n",beg+16);
	    }
	  }

	  for (i = 0;; i+=2) {
	    x = readbig((char*) (tab+i));
	    y = readbig((char*) (tab+i+1));

	    if (!x)
	      break;

	    switch (x) {
	    case 0x80004459:
	      if (credits) {
	        strlcat(credits, "PLAYERNAME:\n", credits_len);
	        strlcat(credits, beg+y, credits_len);
	        strlcat(credits, "\n\n", credits_len);
	      } else { 
	        printf("playername:\t%s\n", beg + y);
	      }
	      break;

	    case 0x8000445a:
	      if (credits) {
	        strlcat(credits, "CREDITS:\n", credits_len);
	        strlcat(credits, beg+y, credits_len);
	        strlcat(credits, "\n\n", credits_len);
	      } else {
		processstring(beg + y);
		printf("credits:\t%s\n",beg+y);
	      }

	    case 0x80004474:
	      if ((y & 0x2) != 0) {
		has_songend = 1;
	      }
	      break;

	    case 0x80004573:
	      is_amplifier = 1;
	      break;

	    case 0x80004455:
	      is_customplayer = 1;
	      break;

	    case 0x80004479:
	    case 0x8000447A:
	      is_noteplayer = 1;
	      break;

	    default:
	      break;
	    }
	  }
	  if (!credits) {
	    printf("song end:\t%s\n", has_songend ? "yes":"no");
	    if (is_amplifier) {
	      printf("amplifier:\tyes\n");
	    }
	    if (is_customplayer) {
	      printf("custom player:\tyes\n");
	    }
	    if (is_noteplayer) {
	      printf("noteplayer:\tyes\n");
	    }
	    printf("\n");
	  }
	  return;
	}
      }
    }
  }
  fprintf(stderr,"%s is not a deliplayer\n",filename);
}

